package org.clank.support.aliases;

import org.clank.support.Converted;
import org.clank.support.*;
import static org.clank.support.NativeType.*;
import static org.clank.support.NativeMemory.*;
import static org.clank.support.NativePointer.*;

/**
 * All containers have to implement this interface
 * @param <T> - stored type
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/nativecontainer.tpl")
//</editor-fold>
public interface ${FILE_NAME}${TEMPLATE_PARAMS} {
  
  /**
   * Generic push back.
   * @param val - value to push back
   */
  void push_back(${VALUE_TYPE} val);
  
  /**
   * Push back for "const ${VALUE_TYPE} &"
   * @param val 
   */
  default void push_back_T$C$R(${VALUE_TYPE} val) {
    push_back(val);
  }

  /**
   * Push back for "${VALUE_TYPE} &&"
   * @param val 
   */
  default void push_back_T$RR(${VALUE_TYPE} val) {
    push_back(val);
  }
}